Index: /trunk/src/sys/kern/sys_pipe.c
===================================================================
--- /trunk/src/sys/kern/sys_pipe.c	(revision 151)
+++ /trunk/src/sys/kern/sys_pipe.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sys_pipe.c,v 1.103.4.5 2009/04/04 23:36:27 snj Exp $	*/
+/*	sys_pipe.c,v 1.103.4.5 2009/04/04 23:36:27 snj Exp	*/
 
 /*-
@@ -69,5 +69,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sys_pipe.c,v 1.103.4.5 2009/04/04 23:36:27 snj Exp $");
+__KERNEL_RCSID(0, "sys_pipe.c,v 1.103.4.5 2009/04/04 23:36:27 snj Exp");
 
 #include <sys/param.h>
@@ -509,4 +509,5 @@
 #ifndef PIPE_NODIRECT
 		if ((rpipe->pipe_state & PIPE_DIRECTR) != 0) {
+			struct pipemapping * const rmap = &rpipe->pipe_map;
 			/*
 			 * Direct copy, bypassing a kernel buffer.
@@ -516,9 +517,9 @@
 			KASSERT(rpipe->pipe_state & PIPE_DIRECTW);
 
-			size = rpipe->pipe_map.cnt;
+			size = rmap->cnt;
 			if (size > uio->uio_resid)
 				size = uio->uio_resid;
 
-			va = (char *)rpipe->pipe_map.kva + rpipe->pipe_map.pos;
+			va = (char *)rmap->kva + rmap->koff + rmap->pos;
 			mutex_exit(lock);
 			error = uiomove(va, size, uio);
@@ -527,7 +528,7 @@
 				break;
 			nread += size;
-			rpipe->pipe_map.pos += size;
-			rpipe->pipe_map.cnt -= size;
-			if (rpipe->pipe_map.cnt == 0) {
+			rmap->pos += size;
+			rmap->cnt -= size;
+			if (rmap->cnt == 0) {
 				rpipe->pipe_state &= ~PIPE_DIRECTR;
 				cv_broadcast(&rpipe->pipe_wcv);
@@ -622,18 +623,17 @@
 pipe_loan_alloc(struct pipe *wpipe, int npages)
 {
-	vsize_t len;
-
-	len = (vsize_t)npages << PAGE_SHIFT;
+	struct pipemapping * const wmap = &wpipe->pipe_map;
+	const vsize_t len = ptoa(npages);
+
 	atomic_add_int(&amountpipekva, len);
-	wpipe->pipe_map.kva = uvm_km_alloc(kernel_map, len, 0,
-	    UVM_KMF_VAONLY | UVM_KMF_WAITVA);
-	if (wpipe->pipe_map.kva == 0) {
+	wmap->kva = uvm_km_alloc(kernel_map, len, 0,
+	    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY | UVM_KMF_WAITVA);
+	if (wmap->kva == 0) {
 		atomic_add_int(&amountpipekva, -len);
 		return (ENOMEM);
 	}
 
-	wpipe->pipe_map.npages = npages;
-	wpipe->pipe_map.pgs = kmem_alloc(npages * sizeof(struct vm_page *),
-	    KM_SLEEP);
+	wmap->npages = npages;
+	wmap->pgs = kmem_alloc(npages * sizeof(struct vm_page *), KM_SLEEP);
 	return (0);
 }
@@ -645,13 +645,17 @@
 pipe_loan_free(struct pipe *wpipe)
 {
-	vsize_t len;
-
-	len = (vsize_t)wpipe->pipe_map.npages << PAGE_SHIFT;
-	uvm_km_free(kernel_map, wpipe->pipe_map.kva, len, UVM_KMF_VAONLY);
-	wpipe->pipe_map.kva = 0;
+	struct pipemapping * const wmap = &wpipe->pipe_map;
+	const vsize_t len = ptoa(wmap->npages);
+
+	uvm_km_free(kernel_map, wmap->kva, len, UVM_KMF_VAONLY);
+	wmap->kva = 0;
 	atomic_add_int(&amountpipekva, -len);
-	kmem_free(wpipe->pipe_map.pgs,
-	    wpipe->pipe_map.npages * sizeof(struct vm_page *));
-	wpipe->pipe_map.pgs = NULL;
+	kmem_free(wmap->pgs, wmap->npages * sizeof(struct vm_page *));
+	wmap->pgs = NULL;
+#if 0
+	wmap->npages = 0;
+	wmap->pos = 0;
+	wmap->cnt = 0;
+#endif
 }
 
@@ -669,4 +673,6 @@
 pipe_direct_write(struct file *fp, struct pipe *wpipe, struct uio *uio)
 {
+	struct pipemapping * const wmap = &wpipe->pipe_map;
+	kmutex_t * const lock = wpipe->pipe_lock;
 	int error, npages, j;
 	struct vm_page **pgs;
@@ -674,8 +680,8 @@
 	vsize_t blen, bcnt;
 	voff_t bpos;
-	kmutex_t *lock = wpipe->pipe_lock;
+	u_int starting_color;
 
 	KASSERT(mutex_owned(wpipe->pipe_lock));
-	KASSERT(wpipe->pipe_map.cnt == 0);
+	KASSERT(wmap->cnt == 0);
 
 	mutex_exit(lock);
@@ -698,5 +704,6 @@
 		bcnt = uio->uio_iov->iov_len;
 	}
-	npages = blen >> PAGE_SHIFT;
+	npages = atop(blen);
+	starting_color = atop(base) & uvmexp.colormask;
 
 	/*
@@ -704,10 +711,10 @@
 	 * allocated.
 	 */
-	if (wpipe->pipe_map.kva != 0 && npages > wpipe->pipe_map.npages)
+	if (wmap->kva != 0 && starting_color + npages > wmap->npages)
 		pipe_loan_free(wpipe);
 
 	/* Allocate new kva. */
-	if (wpipe->pipe_map.kva == 0) {
-		error = pipe_loan_alloc(wpipe, npages);
+	if (wmap->kva == 0) {
+		error = pipe_loan_alloc(wpipe, starting_color + npages);
 		if (error) {
 			mutex_enter(lock);
@@ -717,5 +724,5 @@
 
 	/* Loan the write buffer memory from writer process */
-	pgs = wpipe->pipe_map.pgs;
+	pgs = wmap->pgs + starting_color;
 	error = uvm_loan(&uio->uio_vmspace->vm_map, base, blen,
 			 pgs, UVM_LOAN_TOPAGE);
@@ -727,5 +734,5 @@
 
 	/* Enter the loaned pages to kva */
-	kva = wpipe->pipe_map.kva;
+	kva = wmap->kva + ptoa(starting_color);
 	for (j = 0; j < npages; j++, kva += PAGE_SIZE) {
 		pmap_kenter_pa(kva, VM_PAGE_TO_PHYS(pgs[j]), VM_PROT_READ);
@@ -734,6 +741,6 @@
 
 	/* Now we can put the pipe in direct write mode */
-	wpipe->pipe_map.pos = bpos;
-	wpipe->pipe_map.cnt = bcnt;
+	wmap->pos = bpos + ptoa(starting_color);
+	wmap->cnt = bcnt;
 
 	/*
@@ -773,5 +780,5 @@
 
 	if (pgs != NULL) {
-		pmap_kremove(wpipe->pipe_map.kva, blen);
+		pmap_kremove(wmap->kva, blen);
 		pmap_update(pmap_kernel());
 		uvm_unloan(pgs, npages, UVM_LOAN_TOPAGE);
@@ -790,11 +797,11 @@
 		 * write, error, or restarting the write(2) as appropriate.
 		 */
-		if (wpipe->pipe_map.cnt == bcnt) {
-			wpipe->pipe_map.cnt = 0;
+		if (wmap->cnt == bcnt) {
+			wmap->cnt = 0;
 			cv_broadcast(&wpipe->pipe_wcv);
 			return (error);
 		}
 
-		bcnt -= wpipe->pipe_map.cnt;
+		bcnt -= wpipe->cnt;
 	}
 
@@ -808,5 +815,5 @@
 	}
 
-	wpipe->pipe_map.cnt = 0;
+	wmap->cnt = 0;
 	return (error);
 }
@@ -1241,5 +1248,4 @@
 		pipe_loan_free(pipe);
 		pipe->pipe_map.cnt = 0;
-		pipe->pipe_map.kva = 0;
 		pipe->pipe_map.pos = 0;
 		pipe->pipe_map.npages = 0;
Index: /trunk/src/sys/kern/tty.c
===================================================================
--- /trunk/src/sys/kern/tty.c	(revision 151)
+++ /trunk/src/sys/kern/tty.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tty.c,v 1.227.4.1.4.1 2010/04/21 00:28:18 matt Exp $	*/
+/*	tty.c,v 1.227.4.1.4.1 2010/04/21 00:28:18 matt Exp	*/
 
 /*-
@@ -64,5 +64,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tty.c,v 1.227.4.1.4.1 2010/04/21 00:28:18 matt Exp $");
+__KERNEL_RCSID(0, "tty.c,v 1.227.4.1.4.1 2010/04/21 00:28:18 matt Exp");
 
 #include <sys/param.h>
@@ -75,4 +75,5 @@
 #include <sys/file.h>
 #include <sys/conf.h>
+#include <sys/cpu.h>
 #include <sys/dkstat.h>
 #include <sys/uio.h>
@@ -2400,13 +2401,34 @@
 	mutex_enter(pick->p_lock);
 	LIST_FOREACH(l, &pick->p_lwps, l_sibling) {
+		const char *lp;
 		lwp_lock(l);
-		snprintf(lmsg, sizeof(lmsg), "%s%s",
-		    l->l_stat == LSONPROC ? "running" :
-		    l->l_stat == LSRUN ? "runnable" :
-		    l->l_wchan ? l->l_wmesg : "iowait",
-		    (LIST_NEXT(l, l_sibling) != NULL) ? " " : "] ");
+#ifdef LWP_PC
+#define FMT_RUN "%#"PRIxVADDR
+#define VAL_RUNNING (vaddr_t)LWP_PC(l)
+#define VAL_RUNABLE (vaddr_t)LWP_PC(l)
+#else
+#define FMT_RUN "%s"
+#define VAL_RUNNING "running"
+#define VAL_RUNABLE "runnable"
+#endif
+		switch (l->l_stat) {
+		case LSONPROC:
+			snprintf(lmsg, sizeof(lmsg), FMT_RUN"/%d", VAL_RUNNING,
+			    cpu_index(l->l_cpu));
+			lp = lmsg;
+			break;
+		case LSRUN:
+			snprintf(lmsg, sizeof(lmsg), FMT_RUN, VAL_RUNABLE);
+			lp = lmsg;
+			break;
+		default:
+			lp = l->l_wchan ? l->l_wmesg : "iowait";
+			break;
+		} 
+		strlcat(buf, lp, bufsz);
+		strlcat(buf, LIST_NEXT(l, l_sibling) != NULL ? " " : "] ",
+		    bufsz);
+		pctcpu += l->l_pctcpu;
 		lwp_unlock(l);
-		strlcat(buf, lmsg, bufsz);
-		pctcpu += l->l_pctcpu;
 	}
 	pctcpu += pick->p_pctcpu;
Index: /trunk/src/sys/kern/uipc_socket.c
===================================================================
--- /trunk/src/sys/kern/uipc_socket.c	(revision 151)
+++ /trunk/src/sys/kern/uipc_socket.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: uipc_socket.c,v 1.177.4.2.2.1.2.1 2010/04/21 00:28:18 matt Exp $	*/
+/*	uipc_socket.c,v 1.177.4.2.2.1.2.1 2010/04/21 00:28:18 matt Exp	*/
 
 /*-
@@ -64,5 +64,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: uipc_socket.c,v 1.177.4.2.2.1.2.1 2010/04/21 00:28:18 matt Exp $");
+__KERNEL_RCSID(0, "uipc_socket.c,v 1.177.4.2.2.1.2.1 2010/04/21 00:28:18 matt Exp");
 
 #include "opt_sock_counters.h"
@@ -200,5 +200,5 @@
 
 vaddr_t
-sokvaalloc(vsize_t len, struct socket *so)
+sokvaalloc(vaddr_t sva, vsize_t len, struct socket *so)
 {
 	vaddr_t lva;
@@ -215,5 +215,6 @@
 	 */
 
-	lva = uvm_km_alloc(kernel_map, len, 0, UVM_KMF_VAONLY | UVM_KMF_WAITVA);
+	lva = uvm_km_alloc(kernel_map, len, atop(sva) & uvmexp.colormask,
+	    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY | UVM_KMF_WAITVA);
 	if (lva == 0) {
 		sokvaunreserve(len);
@@ -363,5 +364,5 @@
 	KASSERT(npgs <= M_EXT_MAXPAGES);
 
-	lva = sokvaalloc(len, so);
+	lva = sokvaalloc(sva, len, so);
 	if (lva == 0)
 		return 0;
Index: /trunk/src/sys/kern/vfs_wapbl.c
===================================================================
--- /trunk/src/sys/kern/vfs_wapbl.c	(revision 151)
+++ /trunk/src/sys/kern/vfs_wapbl.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: vfs_wapbl.c,v 1.3.8.1 2009/02/24 04:13:35 snj Exp $	*/
+/*	$NetBSD: vfs_wapbl.c,v 1.3.8.1.4.1 2011/05/20 08:11:27 matt Exp $	*/
 
 /*-
@@ -34,5 +34,5 @@
  */
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: vfs_wapbl.c,v 1.3.8.1 2009/02/24 04:13:35 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: vfs_wapbl.c,v 1.3.8.1.4.1 2011/05/20 08:11:27 matt Exp $");
 
 #include <sys/param.h>
@@ -2073,5 +2073,5 @@
 			continue;
 		wr->wr_blkhash = wapbl_malloc(hashsize * sizeof(*wr->wr_blkhash));
-		for (i = 0; i < wr->wr_blkhashmask; i++)
+		for (i = 0; i < hashsize; i++)
 			LIST_INIT(&wr->wr_blkhash[i]);
 		wr->wr_blkhashmask = hashsize - 1;
Index: /trunk/src/sys/kern/vfs_xattr.c
===================================================================
--- /trunk/src/sys/kern/vfs_xattr.c	(revision 151)
+++ /trunk/src/sys/kern/vfs_xattr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: vfs_xattr.c,v 1.19 2008/06/23 11:30:41 ad Exp $	*/
+/*	$NetBSD: vfs_xattr.c,v 1.19.14.1 2011/05/20 08:11:28 matt Exp $	*/
 
 /*-
@@ -69,5 +69,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: vfs_xattr.c,v 1.19 2008/06/23 11:30:41 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: vfs_xattr.c,v 1.19.14.1 2011/05/20 08:11:28 matt Exp $");
 
 #include <sys/param.h>
@@ -150,5 +150,5 @@
 		syscallarg(const char *) attrname;
 	} */
-	struct vnode *vp;
+	struct vnode *vp, *path_vp;
 	struct nameidata nd;
 	char attrname[EXTATTR_MAXNAMELEN];
@@ -162,4 +162,11 @@
 	}
 
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path));
+	error = namei(&nd);
+	if (error) {
+		return (error);
+	}
+	path_vp = nd.ni_vp;
+
 	vp = NULL;
 	if (SCARG(uap, filename) != NULL) {
@@ -167,18 +174,12 @@
 		    SCARG(uap, filename));
 		error = namei(&nd);
-		if (error)
+		if (error) {
+			vrele(path_vp);
 			return (error);
+		}
 		vp = nd.ni_vp;
 	}
 
-	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path));
-	error = namei(&nd);
-	if (error) {
-		if (vp != NULL)
-			vput(vp);
-		return (error);
-	}
-
-	error = VFS_EXTATTRCTL(nd.ni_vp->v_mount, SCARG(uap, cmd), vp,
+	error = VFS_EXTATTRCTL(path_vp->v_mount, SCARG(uap, cmd), vp,
 	    SCARG(uap, attrnamespace),
 	    SCARG(uap, attrname) != NULL ? attrname : NULL);
@@ -186,4 +187,5 @@
 	if (vp != NULL)
 		vrele(vp);
+	vrele(path_vp);
 
 	return (error);
Index: /trunk/src/sys/lib/libkern/libkern.h
===================================================================
--- /trunk/src/sys/lib/libkern/libkern.h	(revision 151)
+++ /trunk/src/sys/lib/libkern/libkern.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: libkern.h,v 1.82.8.1 2010/04/21 00:28:20 matt Exp $	*/
+/*	$NetBSD: libkern.h,v 1.82.8.3 2011/04/29 08:10:38 matt Exp $	*/
 
 /*-
@@ -193,7 +193,5 @@
 #endif
 
-#define	CTASSERT(x)		_CTASSERT(x, __LINE__)
-#define	_CTASSERT(x, y)		__CTASSERT(x, y)
-#define	__CTASSERT(x, y)	typedef char __ctassert ## y[(x) ? 1 : -1];
+#define	CTASSERT(x)		__CTASSERT(x)
 
 #ifndef DIAGNOSTIC
@@ -209,5 +207,5 @@
 #define _DIAGASSERT(a)	assert(a)
 #define	KASSERTMSG(e, msg) do {		\
-	if (__predict_false((e)))	\
+	if (__predict_false(!(e)))	\
 		panic msg;		\
 	} while (/*CONSTCOND*/ 0)
@@ -223,9 +221,15 @@
 #ifndef DEBUG
 #ifdef lint
-#define	KDASSERT(e)	/* NOTHING */
+#define	KDASSERTMSG(e, msg)	/* NOTHING */
+#define	KDASSERT(e)		/* NOTHING */
 #else /* lint */
-#define	KDASSERT(e)	((void)0)
+#define	KDASSERTMSG(e, msg)	((void)0)
+#define	KDASSERT(e)		((void)0)
 #endif /* lint */
 #else
+#define	KDASSERTMSG(e, msg) do {	\
+	if (__predict_false(!(e)))	\
+		panic msg;		\
+	} while (/*CONSTCOND*/ 0)
 #ifdef __STDC__
 #define	KDASSERT(e)	(__predict_true((e)) ? (void)0 :		    \
Index: /trunk/src/sys/lib/libkern/softfloat.c
===================================================================
--- /trunk/src/sys/lib/libkern/softfloat.c	(revision 151)
+++ /trunk/src/sys/lib/libkern/softfloat.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: softfloat.c,v 1.4 2005/12/11 12:24:37 christos Exp $ */
+/* $NetBSD: softfloat.c,v 1.4.94.2 2011/02/08 19:00:14 cliff Exp $ */
 
 /*
@@ -50,5 +50,5 @@
 #include <sys/cdefs.h>
 #if defined(LIBC_SCCS) && !defined(lint)
-__RCSID("$NetBSD: softfloat.c,v 1.4 2005/12/11 12:24:37 christos Exp $");
+__RCSID("$NetBSD: softfloat.c,v 1.4.94.2 2011/02/08 19:00:14 cliff Exp $");
 #endif /* LIBC_SCCS and not lint */
 
Index: /trunk/src/sys/miscfs/genfs/genfs_io.c
===================================================================
--- /trunk/src/sys/miscfs/genfs/genfs_io.c	(revision 151)
+++ /trunk/src/sys/miscfs/genfs/genfs_io.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: genfs_io.c,v 1.13.4.2 2009/04/04 18:14:50 snj Exp $	*/
+/*	genfs_io.c,v 1.13.4.2.4.2 2011/05/20 08:11:28 matt Exp	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: genfs_io.c,v 1.13.4.2 2009/04/04 18:14:50 snj Exp $");
+__KERNEL_RCSID(0, "genfs_io.c,v 1.13.4.2.4.2 2011/05/20 08:11:28 matt Exp");
 
 #include <sys/param.h>
@@ -127,4 +127,5 @@
 	const bool overwrite = (flags & PGO_OVERWRITE) != 0;
 	const bool blockalloc = write && (flags & PGO_NOBLOCKALLOC) == 0;
+	const bool glocked = (flags & PGO_GLOCKHELD) != 0;
 	voff_t origvsize;
 	UVMHIST_FUNC("genfs_getpages"); UVMHIST_CALLED(ubchist);
@@ -215,4 +216,5 @@
 		int nfound;
 
+		KASSERT(!glocked);
 		npages = *ap->a_count;
 #if defined(DEBUG)
@@ -229,5 +231,5 @@
 			goto out_err;
 		}
-		if (!rw_tryenter(&gp->g_glock, RW_READER)) {
+		if (!genfs_node_rdtrylock(vp)) {
 			genfs_rel_pages(ap->a_m, npages);
 
@@ -244,5 +246,5 @@
 			}
 		} else {
-			rw_exit(&gp->g_glock);
+			genfs_node_unlock(vp);
 		}
 		error = (ap->a_m[ap->a_centeridx] == NULL ? EBUSY : 0);
@@ -303,12 +305,17 @@
 	 */
 
-	if (blockalloc) {
-		rw_enter(&gp->g_glock, RW_WRITER);
-	} else {
-		rw_enter(&gp->g_glock, RW_READER);
+	KASSERT(!glocked || genfs_node_wrlocked(vp));
+	if (!glocked) {
+		if (blockalloc) {
+			genfs_node_wrlock(vp);
+		} else {
+			genfs_node_rdlock(vp);
+		}
 	}
 	mutex_enter(&uobj->vmobjlock);
 	if (vp->v_size < origvsize) {
-		rw_exit(&gp->g_glock);
+		if (!glocked) {
+			genfs_node_unlock(vp);
+		}
 		if (pgs != pgs_onstack)
 			kmem_free(pgs, pgs_size);
@@ -318,5 +325,7 @@
 	if (uvn_findpages(uobj, origoffset, &npages, &pgs[ridx],
 	    async ? UFP_NOWAIT : UFP_ALL) != orignpages) {
-		rw_exit(&gp->g_glock);
+		if (!glocked) {
+			genfs_node_unlock(vp);
+		}
 		KASSERT(async != 0);
 		genfs_rel_pages(&pgs[ridx], orignpages);
@@ -339,5 +348,7 @@
 	}
 	if (i == npages) {
-		rw_exit(&gp->g_glock);
+		if (!glocked) {
+			genfs_node_unlock(vp);
+		}
 		UVMHIST_LOG(ubchist, "returning cached pages", 0,0,0,0);
 		npages += ridx;
@@ -350,5 +361,7 @@
 
 	if (overwrite) {
-		rw_exit(&gp->g_glock);
+		if (!glocked) {
+			genfs_node_unlock(vp);
+		}
 		UVMHIST_LOG(ubchist, "PGO_OVERWRITE",0,0,0,0);
 
@@ -385,5 +398,7 @@
 		if (uvn_findpages(uobj, startoffset, &npgs, pgs,
 		    async ? UFP_NOWAIT : UFP_ALL) != npages) {
-			rw_exit(&gp->g_glock);
+			if (!glocked) {
+				genfs_node_unlock(vp);
+			}
 			KASSERT(async != 0);
 			genfs_rel_pages(pgs, npages);
@@ -566,5 +581,7 @@
 	if (async) {
 		UVMHIST_LOG(ubchist, "returning 0 (async)",0,0,0,0);
-		rw_exit(&gp->g_glock);
+		if (!glocked) {
+			genfs_node_unlock(vp);
+		}
 		error = 0;
 		goto out_err;
@@ -614,5 +631,7 @@
 		}
 	}
-	rw_exit(&gp->g_glock);
+	if (!glocked) {
+		genfs_node_unlock(vp);
+	}
 	mutex_enter(&uobj->vmobjlock);
 
@@ -846,5 +865,4 @@
 	    ((endoff - startoff) >> PAGE_SHIFT) * UVM_PAGE_HASH_PENALTY);
 
-#if !defined(DEBUG)
 	/*
 	 * if this vnode is known not to have dirty pages,
@@ -853,10 +871,11 @@
 
 	if ((vp->v_iflag & VI_ONWORKLST) == 0) {
+#if !defined(DEBUG)
 		if ((flags & (PGO_FREE|PGO_DEACTIVATE)) == 0) {
 			goto skip_scan;
 		}
+#endif /* !defined(DEBUG) */
 		flags &= ~PGO_CLEANIT;
 	}
-#endif /* !defined(DEBUG) */
 
 	/*
@@ -1728,7 +1747,9 @@
 	upm = vm_map_pmap(map);
 	kpm = vm_map_pmap(kernel_map);
-	kva = uvm_km_alloc(kernel_map, klen, 0,
-			   UVM_KMF_VAONLY | UVM_KMF_WAITVA);
 	puva = trunc_page(uva);
+
+	kva = uvm_km_alloc(kernel_map, klen, atop(puva) & uvmexp.colormask,
+	    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY | UVM_KMF_WAITVA);
+
 	for (poff = 0; poff < klen; poff += PAGE_SIZE) {
 		rv = pmap_extract(upm, puva + poff, &pa);
Index: /trunk/src/sys/miscfs/genfs/genfs_node.h
===================================================================
--- /trunk/src/sys/miscfs/genfs/genfs_node.h	(revision 151)
+++ /trunk/src/sys/miscfs/genfs/genfs_node.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: genfs_node.h,v 1.17 2008/05/14 16:49:47 reinoud Exp $ */
+/* $NetBSD: genfs_node.h,v 1.17.16.1 2011/05/20 08:11:28 matt Exp $ */
 
 /*
@@ -92,5 +92,7 @@
 void	genfs_node_wrlock(struct vnode *);
 void	genfs_node_rdlock(struct vnode *);
+int	genfs_node_rdtrylock(struct vnode *);
 void	genfs_node_unlock(struct vnode *);
+int	genfs_node_wrlocked(struct vnode *);
 
 #endif	/* _MISCFS_GENFS_GENFS_NODE_H_ */
Index: /trunk/src/sys/miscfs/genfs/genfs_vnops.c
===================================================================
--- /trunk/src/sys/miscfs/genfs/genfs_vnops.c	(revision 151)
+++ /trunk/src/sys/miscfs/genfs/genfs_vnops.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: genfs_vnops.c,v 1.167 2008/04/28 20:24:08 martin Exp $	*/
+/*	$NetBSD: genfs_vnops.c,v 1.167.18.1 2011/05/20 08:11:28 matt Exp $	*/
 
 /*-
@@ -58,5 +58,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: genfs_vnops.c,v 1.167 2008/04/28 20:24:08 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: genfs_vnops.c,v 1.167.18.1 2011/05/20 08:11:28 matt Exp $");
 
 #include <sys/param.h>
@@ -494,4 +494,12 @@
 }
 
+int
+genfs_node_rdtrylock(struct vnode *vp)
+{
+	struct genfs_node *gp = VTOG(vp);
+
+	return rw_tryenter(&gp->g_glock, RW_READER);
+}
+
 void
 genfs_node_unlock(struct vnode *vp)
@@ -501,2 +509,10 @@
 	rw_exit(&gp->g_glock);
 }
+
+int
+genfs_node_wrlocked(struct vnode *vp)
+{
+	struct genfs_node *gp = VTOG(vp);
+
+	return rw_write_held(&gp->g_glock);
+}
Index: /trunk/src/sys/miscfs/procfs/procfs_linux.c
===================================================================
--- /trunk/src/sys/miscfs/procfs/procfs_linux.c	(revision 151)
+++ /trunk/src/sys/miscfs/procfs/procfs_linux.c	(revision 152)
@@ -1,3 +1,3 @@
-/*      $NetBSD: procfs_linux.c,v 1.54.14.1 2010/04/21 00:28:20 matt Exp $      */
+/*      $NetBSD: procfs_linux.c,v 1.54.14.3 2011/04/29 08:12:08 matt Exp $      */
 
 /*
@@ -37,5 +37,9 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: procfs_linux.c,v 1.54.14.1 2010/04/21 00:28:20 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: procfs_linux.c,v 1.54.14.3 2011/04/29 08:12:08 matt Exp $");
+
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
 
 #include <sys/param.h>
Index: /trunk/src/sys/net/bpf_filter.c
===================================================================
--- /trunk/src/sys/net/bpf_filter.c	(revision 151)
+++ /trunk/src/sys/net/bpf_filter.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bpf_filter.c,v 1.35 2008/08/20 13:01:54 joerg Exp $	*/
+/*	$NetBSD: bpf_filter.c,v 1.35.12.1 2011/05/20 08:11:29 matt Exp $	*/
 
 /*-
@@ -38,5 +38,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: bpf_filter.c,v 1.35 2008/08/20 13:01:54 joerg Exp $");
+__KERNEL_RCSID(0, "$NetBSD: bpf_filter.c,v 1.35.12.1 2011/05/20 08:11:29 matt Exp $");
 
 #if 0
@@ -514,5 +514,5 @@
 				 * Check for constant division by 0.
 				 */
-				if (BPF_RVAL(p->code) == BPF_K && p->k == 0)
+				if (BPF_SRC(p->code) == BPF_K && p->k == 0)
 					return 0;
 				break;
Index: /trunk/src/sys/net/if.c
===================================================================
--- /trunk/src/sys/net/if.c	(revision 151)
+++ /trunk/src/sys/net/if.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: if.c,v 1.230.4.1.4.1 2010/04/21 00:28:21 matt Exp $	*/
+/*	$NetBSD: if.c,v 1.230.4.1.4.2 2011/05/20 08:11:29 matt Exp $	*/
 
 /*-
@@ -91,5 +91,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: if.c,v 1.230.4.1.4.1 2010/04/21 00:28:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: if.c,v 1.230.4.1.4.2 2011/05/20 08:11:29 matt Exp $");
 
 #include "opt_inet.h"
@@ -1714,5 +1714,5 @@
 #ifdef COMPAT_OIFREQ
 	if (cmd != ocmd)
-		ifreqn2o(oifr, ifr);
+		ifreqn2o(ifr, oifr);
 #endif
 
Index: /trunk/src/sys/net/route.c
===================================================================
--- /trunk/src/sys/net/route.c	(revision 151)
+++ /trunk/src/sys/net/route.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: route.c,v 1.113.4.1 2009/04/03 17:59:03 snj Exp $	*/
+/*	$NetBSD: route.c,v 1.113.4.1.4.1 2010/08/16 18:42:58 matt Exp $	*/
 
 /*-
@@ -94,5 +94,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: route.c,v 1.113.4.1 2009/04/03 17:59:03 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: route.c,v 1.113.4.1.4.1 2010/08/16 18:42:58 matt Exp $");
 
 #include <sys/param.h>
@@ -377,5 +377,5 @@
 	struct rtentry *rt;
 	int error = 0;
-	u_quad_t *stat = NULL;
+	uint64_t *stat = NULL;
 	struct rt_addrinfo info;
 	struct ifaddr *ifa;
Index: /trunk/src/sys/net/route.h
===================================================================
--- /trunk/src/sys/net/route.h	(revision 151)
+++ /trunk/src/sys/net/route.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: route.h,v 1.70.16.1.4.2 2010/05/13 05:34:58 matt Exp $	*/
+/*	$NetBSD: route.h,v 1.70.16.1.4.3 2010/08/16 18:42:58 matt Exp $	*/
 
 /*
@@ -68,14 +68,14 @@
  */
 struct rt_metrics {
-	u_quad_t rmx_locks;	/* Kernel must leave these values alone */
-	u_quad_t rmx_mtu;	/* MTU for this path */
-	u_quad_t rmx_hopcount;	/* max hops expected */
-	u_quad_t rmx_expire;	/* lifetime for route, e.g. redirect */
-	u_quad_t rmx_recvpipe;	/* inbound delay-bandwidth product */
-	u_quad_t rmx_sendpipe;	/* outbound delay-bandwidth product */
-	u_quad_t rmx_ssthresh;	/* outbound gateway buffer limit */
-	u_quad_t rmx_rtt;	/* estimated round trip time */
-	u_quad_t rmx_rttvar;	/* estimated rtt variance */
-	u_quad_t rmx_pksent;	/* packets sent using this route */
+	uint64_t rmx_locks;	/* Kernel must leave these values alone */
+	uint64_t rmx_mtu;	/* MTU for this path */
+	uint64_t rmx_hopcount;	/* max hops expected */
+	uint64_t rmx_expire;	/* lifetime for route, e.g. redirect */
+	uint64_t rmx_recvpipe;	/* inbound delay-bandwidth product */
+	uint64_t rmx_sendpipe;	/* outbound delay-bandwidth product */
+	uint64_t rmx_ssthresh;	/* outbound gateway buffer limit */
+	uint64_t rmx_rtt;	/* estimated round trip time */
+	uint64_t rmx_rttvar;	/* estimated rtt variance */
+	uint64_t rmx_pksent;	/* packets sent using this route */
 };
 
@@ -160,9 +160,9 @@
  */
 struct	rtstat {
-	u_quad_t rts_badredirect;	/* bogus redirect calls */
-	u_quad_t rts_dynamic;		/* routes created by redirects */
-	u_quad_t rts_newgateway;	/* routes modified by redirects */
-	u_quad_t rts_unreach;		/* lookups which failed */
-	u_quad_t rts_wildcard;		/* lookups satisfied by a wildcard */
+	uint64_t rts_badredirect;	/* bogus redirect calls */
+	uint64_t rts_dynamic;		/* routes created by redirects */
+	uint64_t rts_newgateway;	/* routes modified by redirects */
+	uint64_t rts_unreach;		/* lookups which failed */
+	uint64_t rts_wildcard;		/* lookups satisfied by a wildcard */
 };
 /*
@@ -180,5 +180,5 @@
 	int	rtm_errno;	/* why failed */
 	int	rtm_use;	/* from rtentry */
-	u_quad_t rtm_inits;	/* which metrics we are initializing */
+	uint64_t rtm_inits;	/* which metrics we are initializing */
 	struct	rt_metrics rtm_rmx; /* metrics themselves */
 };
@@ -245,5 +245,5 @@
 
 #define RT_ROUNDUP(a) \
-	((a) > 0 ? (1 + (((a) - 1) | (sizeof(u_quad_t) - 1))) : sizeof(u_quad_t))
+	((a) > 0 ? (1 + (((a) - 1) | (sizeof(uint64_t) - 1))) : sizeof(uint64_t))
 #define RT_ADVANCE(x, n) (x += RT_ROUNDUP((n)->sa_len))
 
Index: /trunk/src/sys/netinet/tcp_input.c
===================================================================
--- /trunk/src/sys/netinet/tcp_input.c	(revision 151)
+++ /trunk/src/sys/netinet/tcp_input.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tcp_input.c,v 1.291.8.1.2.1 2010/04/21 00:28:22 matt Exp $	*/
+/*	$NetBSD: tcp_input.c,v 1.291.8.1.2.2 2011/05/20 08:11:29 matt Exp $	*/
 
 /*
@@ -146,5 +146,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tcp_input.c,v 1.291.8.1.2.1 2010/04/21 00:28:22 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: tcp_input.c,v 1.291.8.1.2.2 2011/05/20 08:11:29 matt Exp $");
 
 #include "opt_inet.h"
@@ -3344,10 +3344,7 @@
 		(void) m_free(sc->sc_ipopts);
 	rtcache_free(&sc->sc_route);
-	if (callout_invoking(&sc->sc_timer))
-		sc->sc_flags |= SCF_DEAD;
-	else {
-		callout_destroy(&sc->sc_timer);
-		pool_put(&syn_cache_pool, sc);
-	}
+	sc->sc_flags |= SCF_DEAD;
+	if (!callout_invoking(&sc->sc_timer))
+		callout_schedule(&(sc)->sc_timer, 1);
 }
 
@@ -3510,5 +3507,9 @@
 	TCP_STATINC(TCP_STAT_SC_TIMED_OUT);
 	syn_cache_rm(sc);
-	syn_cache_put(sc);	/* calls pool_put but see spl above */
+	if (sc->sc_ipopts)
+		(void) m_free(sc->sc_ipopts);
+	rtcache_free(&sc->sc_route);
+	callout_destroy(&sc->sc_timer);
+	pool_put(&syn_cache_pool, sc);
 	KERNEL_UNLOCK_ONE(NULL);
 	mutex_exit(softnet_lock);
@@ -4183,4 +4184,9 @@
 	} else {
 		s = splsoftnet();
+		/*
+		 * syn_cache_put() will try to schedule the timer, so
+		 * we need to initialize it
+		 */
+		SYN_CACHE_TIMER_ARM(sc);
 		syn_cache_put(sc);
 		splx(s);
Index: /trunk/src/sys/netinet6/udp6_output.c
===================================================================
--- /trunk/src/sys/netinet6/udp6_output.c	(revision 151)
+++ /trunk/src/sys/netinet6/udp6_output.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: udp6_output.c,v 1.37 2008/10/24 22:30:32 dyoung Exp $	*/
+/*	$NetBSD: udp6_output.c,v 1.37.12.1 2011/05/20 08:11:29 matt Exp $	*/
 /*	$KAME: udp6_output.c,v 1.43 2001/10/15 09:19:52 itojun Exp $	*/
 
@@ -63,5 +63,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: udp6_output.c,v 1.37 2008/10/24 22:30:32 dyoung Exp $");
+__KERNEL_RCSID(0, "$NetBSD: udp6_output.c,v 1.37.12.1 2011/05/20 08:11:29 matt Exp $");
 
 #include "opt_inet.h"
@@ -127,5 +127,6 @@
 	u_int16_t fport;
 	int error = 0;
-	struct ip6_pktopts *optp, opt;
+	struct ip6_pktopts *optp = NULL;
+	struct ip6_pktopts opt;
 	int priv;
 	int af = AF_INET6, hlen = sizeof(struct ip6_hdr);
@@ -168,5 +169,5 @@
 			scope_ambiguous = 1;
 		if ((error = sa6_embedscope(sin6, ip6_use_defzone)) != 0)
-			return (error);
+			goto release;
 	}
 
@@ -409,5 +410,6 @@
 releaseopt:
 	if (control) {
-		ip6_clearpktopts(&opt, -1);
+		if (optp == &opt)
+			ip6_clearpktopts(&opt, -1);
 		m_freem(control);
 	}
Index: /trunk/src/sys/netsmb/mchain.h
===================================================================
--- /trunk/src/sys/netsmb/mchain.h	(revision 151)
+++ /trunk/src/sys/netsmb/mchain.h	(revision 152)
@@ -60,6 +60,6 @@
 	struct mbuf *	mb_top;		/* head of mbufs chain */
 	struct mbuf * 	mb_cur;		/* current mbuf */
-	int		mb_mleft;	/* free space in the current mbuf */
-	int		mb_count;	/* total number of bytes */
+	size_t		mb_mleft;	/* free space in the current mbuf */
+	size_t		mb_count;	/* total number of bytes */
 	mb_copy_t *	mb_copy;	/* user defined copy function */
 	void *		mb_udata;	/* user data */
@@ -79,5 +79,5 @@
 struct mbuf *mb_detach(struct mbchain *mbp);
 int  mb_fixhdr(struct mbchain *mbp);
-void *mb_reserve(struct mbchain *mbp, int size);
+void *mb_reserve(struct mbchain *mbp, size_t size);
 
 int  mb_put_uint8(struct mbchain *mbp, u_int8_t x);
@@ -88,7 +88,7 @@
 int  mb_put_int64be(struct mbchain *mbp, int64_t x);
 int  mb_put_int64le(struct mbchain *mbp, int64_t x);
-int  mb_put_mem(struct mbchain *mbp, const char * source, int size, int type);
+int  mb_put_mem(struct mbchain *mbp, const char * source, size_t size, int type);
 int  mb_put_mbuf(struct mbchain *mbp, struct mbuf *m);
-int  mb_put_uio(struct mbchain *mbp, struct uio *uiop, int size);
+int  mb_put_uio(struct mbchain *mbp, struct uio *uiop, size_t size);
 
 int  md_init(struct mdchain *mdp);
@@ -107,7 +107,7 @@
 int  md_get_int64be(struct mdchain *mdp, int64_t *x);
 int  md_get_int64le(struct mdchain *mdp, int64_t *x);
-int  md_get_mem(struct mdchain *mdp, void *target, int size, int type);
+int  md_get_mem(struct mdchain *mdp, void *target, size_t size, int type);
 int  md_get_mbuf(struct mdchain *mdp, int size, struct mbuf **m);
-int  md_get_uio(struct mdchain *mdp, struct uio *uiop, int size);
+int  md_get_uio(struct mdchain *mdp, struct uio *uiop, size_t size);
 
 #endif	/* ifdef _KERNEL */
Index: /trunk/src/sys/netsmb/smb_dev.h
===================================================================
--- /trunk/src/sys/netsmb/smb_dev.h	(revision 151)
+++ /trunk/src/sys/netsmb/smb_dev.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: smb_dev.h,v 1.6 2006/05/14 21:20:13 elad Exp $	*/
+/*	$NetBSD: smb_dev.h,v 1.6.82.1 2011/05/20 08:11:30 matt Exp $	*/
 
 /*
@@ -68,7 +68,7 @@
 struct smbioc_ossn {
 	int		ioc_opt;
-	int		ioc_svlen;	/* size of ioc_server address */
+	uint32_t	ioc_svlen;	/* size of ioc_server address */
 	struct sockaddr*ioc_server;
-	int		ioc_lolen;	/* size of ioc_local address */
+	uint32_t	ioc_lolen;	/* size of ioc_local address */
 	struct sockaddr*ioc_local;
 	char		ioc_srvname[SMB_MAXSRVNAMELEN + 1];
Index: /trunk/src/sys/netsmb/smb_subr.c
===================================================================
--- /trunk/src/sys/netsmb/smb_subr.c	(revision 151)
+++ /trunk/src/sys/netsmb/smb_subr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: smb_subr.c,v 1.32 2008/06/24 10:37:19 gmcgarry Exp $	*/
+/*	$NetBSD: smb_subr.c,v 1.32.14.1 2011/05/20 08:11:30 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: smb_subr.c,v 1.32 2008/06/24 10:37:19 gmcgarry Exp $");
+__KERNEL_RCSID(0, "$NetBSD: smb_subr.c,v 1.32.14.1 2011/05/20 08:11:30 matt Exp $");
 
 #include <sys/param.h>
@@ -97,5 +97,5 @@
 {
 	char *p;
-	int len;
+	size_t len;
 
 	len = s ? strlen(s) + 1 : 1;
@@ -112,8 +112,8 @@
  */
 char *
-smb_strdupin(char *s, int maxlen)
+smb_strdupin(char *s, size_t maxlen)
 {
 	char *p, bt;
-	int len = 0;
+	size_t len = 0;
 
 	for (p = s; ;p++) {
@@ -135,5 +135,5 @@
  */
 void *
-smb_memdupin(void *umem, int len)
+smb_memdupin(void *umem, size_t len)
 {
 	char *p;
@@ -161,5 +161,5 @@
 
 void *
-smb_zmalloc(unsigned long size, struct malloc_type *type, int flags)
+smb_zmalloc(size_t size, struct malloc_type *type, int flags)
 {
 
@@ -180,10 +180,10 @@
 m_dumpm(struct mbuf *m) {
 	char *p;
-	int len;
+	size_t len;
 	printf("d=");
 	while(m) {
-		p=mtod(m,char *);
-		len=m->m_len;
-		printf("(%d)",len);
+		p = mtod(m,char *);
+		len = m->m_len;
+		printf("(%zu)", len);
 		while(len--){
 			printf("%02x ",((int)*(p++)) & 0xff);
@@ -316,5 +316,5 @@
 int
 smb_put_dmem(struct mbchain *mbp, struct smb_vc *vcp, const char *src,
-	int size, int caseopt)
+	size_t size, int caseopt)
 {
 	struct iconv_drv *dp = vcp->vc_toserver;
